package com.psyoblade.algorithms;

import java.util.LinkedList;

public class InsertionSort {
	private	int[] array;
	private	LinkedList<Integer> list;
	
	InsertionSort(int[] outputArray) {
		this.array = outputArray;
		this.list = new LinkedList<Integer>();
	}

	public void sort() { // insertion-sort using linked-list
		this.list.add(this.array[0]);
		for (int i = 1; i < this.array.length; i++) {
			int j = i - 1;
			while (this.list.get(j) > this.array[i]) {
				j--;
				if (j < 0) break;
			}
			if (j < this.list.size()) {
				this.list.add(j + 1, this.array[i]);
			} else {
				this.list.add(this.array[i]);
			}
		}
		assert(this.array.length == this.list.size());
		for (int i = 0; i < this.list.size(); i++){
			this.array[i] = this.list.get(i);
		}
	}
	
	public void sort2() { // insertion-sort using memory-copy
		int[] buffer = new int[array.length];
		buffer[0] = array[0];
		for (int i = 1; i < array.length; i++) {
			int j = i - 1;
			int temp = array[i];
			while (temp < buffer[j]) {
				buffer[j+1] = buffer[j];
				j--;
				if (j < 0)
					break;
			}
			buffer[j+1] = temp;
		}
		assert(this.array.length == buffer.length);
		for (int i = 0; i < this.array.length; i++){
			this.array[i] = buffer[i];
		}
	}
}
