package com.psyoblade.algorithms;

import junit.framework.TestCase;
import java.util.Date;

public class TestInsertionSort extends TestCase {
	Date ellapsed = new Date();
	Date start = null;
	Date end = null;
	static int max = 100;

	protected void setUp() throws Exception {
		super.setUp();
		start = new Date();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		end = new Date();
		long diff = end.getTime() - start.getTime();
		System.out.println("Elapsed time: " + diff + " sec");
	}
	
	public static void printArray(int[] array, int limit) {
		for (int i = 0; i < array.length; i++) {
			if (i >= limit)
				break;
			System.out.println(i + ":" + array[i]);
		}
	}
	
	public static void assertPositiveArray(int[] array) {
		for (int i = 0; i < array.length; i++) {
			assert(array[i] > 0);
		}
	}
	
	public static void assertSorted(int[] array) {
		int before = array[0];
		for (int i = 1; i < array.length; i++) {
			assert(before < array[i]);
			before = array[i];
		}
	}
	
	public void _testRandomNumber() {
		System.out.println(Integer.MAX_VALUE/2000);
		int[] outputArray = new int[Integer.MAX_VALUE/2000];
		boolean positive = true;
		printArray(outputArray, 10);
		RandomNumber.shuffle(outputArray, positive);
		printArray(outputArray, 10);
		assertPositiveArray(outputArray);
	}
	
	public void _testListBasedInsertionSort() {
		int[] outputArray = new int[TestInsertionSort.max];
		boolean positive = true;
		RandomNumber.shuffle(outputArray, positive);
		InsertionSort is = new InsertionSort(outputArray);
		is.sort();
		assertSorted(outputArray);
	}
	
	public void _testMemoryBasedInsertionSort() {
		int[] outputArray = new int[TestInsertionSort.max];
		boolean positive = true;
		RandomNumber.shuffle(outputArray, positive);
		InsertionSort is = new InsertionSort(outputArray);
		is.sort2();
		assertSorted(outputArray);
	}
}
